@ECHO OFF
::    DBGS2BAT.BAT packs DEBUG script(s) into batch file
::  (c) John Paul Jones, as featured in HP Palmtop Paper's 2000 Infobase
::    Use: DBGS2BAT NewFileName.BAT FileSpec.SCR [order]
:: Required: QBasic.EXE & FIND.EXE in dir. in path
:: (DBGS2BAT.BAT is the same as DEBS2BAT.BAT but updated for Windows XP)
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  :: The 1st param designates a new batch file into which ::
  :: the script(s) will be packed; the 2nd parameter des- ::
  :: ignates the  script(s) to be  packed and can contain ::
  :: wildcards, e.g., CALL DEBS2BAT SCR.BAT *.SCR [Enter] ::
  :: would pack all scripts in the current directory into ::
  :: into a batch file called SCR.BAT,  in which case any ::
  :: script in SCR.BAT could be unpacked (re-created as a ::
  :: seperate file) by calling  SCR.BAT  with the name of ::
  :: script to unpack.  So,  if DRV.SCR was packed,  then ::
  :: the command: CALL SCR DRV [Enter] would jettison the ::
  :: DRV.SCR from SCR.BAT.  The 3rd parameter is optional ::
  :: and uses the same syntax as the DOS DIR command--use ::
  :: if you want to sort the order of packed scripts, but ::
  :: but omit the forward slash. To unpack all scripts in ::
  :: the output file, pass an asterik, e.g.,   CALL SCR * ::
  ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
FOR %%v IN (Scr ScrHlp io Ord ScrFile BatFile Clue isp ScrEnd) DO SET %%v=
FOR %%v IN (%1 %2) DO IF %%v!==! GOTO HlpScr2B
IF %1!==! GOTO HlpScr2B
IF %2!==! GOTO HlpScr2B
IF EXIST %1 ECHO %1 already exists
IF EXIST %1 GOTO HlpScr2B
ECHO %1 | FIND /I ".BAT" > NUL
IF ERRORLEVEL 1 SET Clue=NewFile (%1) must have .BAT extension
IF ERRORLEVEL 1 GOTO HlpScr2B
FOR %%v IN (%2) DO SET scr=%%v
IF [%scr%]==[] ECHO "%2" file(s) not found.
IF [%scr%]==[] GOTO HlpScr2B
IF NOT EXIST %scr% ECHO File(s) specified not found
IF NOT EXIST %scr% GOTO HlpScr2B
FOR %%v IN (%path%) DO IF EXIST %%v\QBASIC.EXE SET isp=%%v
IF [%isp%]==[] ECHO QBasic.EXE required in path.
IF [%isp%]==[] GOTO HlpScr2b
ECHO Checking files.....please wait.
COPY %2 %isp%\ScrTestr.TMP > NUL
REM Using FIND to check 4 pipes results in error can't  4 them here
REM Set default order as alphabetical
SET Ord=/o:n
FOR %%v IN (s -s d -d n -n) DO IF %3!==%%v! SET ord=/o:%%v
FOR %%v IN (S -S D -D N -N) DO IF %3!==%%v! SET ord=/o:%%v
REM REMREMREMREMREMREMREMREMREMREMREMREMREM REM
REM  3rd parameter = order of packed files  REM
REM   s   Pack by size smallest to largest  REM
REM  -s  Pack by size largest to smallest   REM
REM   d   Pack by time earliest to latest   REM
REM  -d  Pack by time latest to earliest    REM
REM   n   Pack alphabetically by root name  REM
REM  -n  Pack reverse alphabetically        REM
REM REMREMREMREMREMREMREMREMREMREMREMREMREM REM
DIR /B %ord% %2 > %isp%\ScrFiles.Lst
REM  REM Now make list of scripts for help file.
DIR /W %ord% %2 | FIND /V "e" > %isp%\ScrFiles.Hlp
SET io=%isp%\QBR.BAS
REM Now make QBasic program to pack script(s)
> %io% ECHO DIM LineOfText AS STRING, Script AS STRING, ScrFile AS STRING, B AS STRING
>>%io% ECHO DIM FileCount AS INTEGER, BatFile AS STRING, Str AS STRING, ScrSpec AS STRING
>>%io% ECHO DIM ScrPath AS STRING
>>%io% ECHO BatFile = (UCASE$(LEFT$("%1", (INSTR("%1", ".") - 1))))
>>%io% ECHO FOR K = 1 TO LEN(BatFile)
>>%io% ECHO  Str = (RIGHT$(BatFile, K))
>>%io% ECHO  IF INSTR(Str, "\") = 1 THEN BatFile = MID$(Str, 2, LEN(Str) + 1)
>>%io% ECHO NEXT K
>>%io% ECHO FOR K = 1 TO LEN("%2")
>>%io% ECHO B = (RIGHT$("%2", K))
>>%io% ECHO IF INSTR(B,"\") = 1 THEN ScrFile = MID$(B, 2, LEN(B) + 1)
>>%io% ECHO IF INSTR(B,"\") = 1 THEN ScrPath = LEFT$("%2",LEN("%2") - (LEN(ScrFile)))
>>%io% ECHO IF INSTR(B,"\") = 1 THEN GOTO EndParse
>>%io% ECHO NEXT K
>>%io% ECHO EndParse:
>>%io% ECHO OPEN "%isp%\ScrFiles.Lst" FOR INPUT AS #1
>>%io% ECHO OPEN "%isp%\ScrFiles.TMP" FOR OUTPUT AS #2
>>%io% ECHO FileCount = 0
>>%io% ECHO  DO UNTIL EOF(1)
>>%io% ECHO   FileCount = Filecount + 1
>>%io% ECHO   LINE INPUT #1, ScrFile
>>%io% ECHO   PRINT "Packing: " + ScrFile + "..................."
>>%io% ECHO   Script = (UCASE$(LEFT$(ScrFile, (INSTR(ScrFile, ".") - 1))))
>>%io% ECHO   PRINT #2, ":" + Script
>>%io% ECHO   PRINT #2, "SET io=" + Script + ".DBG"
>>%io% ECHO   PRINT #2, "TYPE NUL>%%io%%"
>>%io% ECHO   PRINT ScrFile
>>%io% ECHO   ScrFile = ScrPath + ScrFile
>>%io% ECHO   OPEN ScrFile FOR INPUT AS #3
>>%io% ECHO     DO UNTIL EOF(3)
>>%io% ECHO     LINE INPUT #3, LineOfText
>>%io% ECHO       IF NOT LineOfText = "" THEN
>>%io% ECHO         PRINT #2, ">>%%io%% ECHO " + LineOfText
>>%io% ECHO       ELSE
>>%io% ECHO         PRINT #2, ">>%%io%% ECHO."
>>%io% ECHO       END IF
>>%io% ECHO     LOOP
>>%io% ECHO     CLOSE #3
>>%io% ECHO     PRINT #2, "DEBUG " + CHR$(060) + " " + Script + ".DBG"
>>%io% ECHO     PRINT #2,  "%%jet%% GOTO x" + Batfile
>>%io% ECHO  LOOP
>>%io% ECHO  OPEN "%isp%\SCR2TMP$.BAT" FOR OUTPUT AS #4
>>%io% ECHO  PRINT #4, "SET FCount=" + LTRIM$(STR$(FileCount))
>>%io% ECHO  PRINT #4, "SET ScrHlp=Hlp" + BatFile
>>%io% ECHO  PRINT #4, "SET ScrEnd=x" + BatFile
>>%io% ECHO  OPEN "%isp%\ScrFiles.Hlp" FOR INPUT AS #5
>>%io% ECHO  OPEN "%isp%\ScrFiles.$$$" FOR OUTPUT AS #6
>>%io% ECHO   IF NOT LineCount = 1 THEN
>>%io% ECHO   PRINT #6, ":Hlp" + BatFile
>>%io% ECHO     DO UNTIL EOF(5)
>>%io% ECHO      LINE INPUT #5, LineOfText
>>%io% ECHO      IF NOT LineOfText = "" THEN PRINT #6, "ECHO " + LineOfText
>>%io% ECHO     LOOP
>>%io% ECHO   ELSE
>>%io% ECHO     REM Do nothing
>>%io% ECHO   END IF
>>%io% ECHO SYSTEM
QBASIC /RUN %io%
REM Calling SCR2TMP$ will create e-var FCount & ScrHlp
CALL %isp%\SCR2TMP$
ECHO @ECHO OFF> %1
IF %FCount%!==1! GOTO Sxi
ECHO SET jet=>>%1
ECHO IF [%%1]==[*] SET jet=REM>>%1
ECHO IF NOT [%%1]==[] IF NOT [%%1]==[*] GOTO %%1>> %1
ECHO IF [%%1]==[] GOTO %ScrHlp% >> %1
:Sxi
TYPE %isp%\ScrFiles.TMP >> %1
TYPE %isp%\ScrFiles.$$$ >> %1
ECHO :%ScrEnd% >> %1
ECHO SET io=>>%1
REM If only one file, remmove superflous code
GOTO EndScr2B
:HlpScr2B
SET Isp=
FOR %%v IN (. %path%) DO IF EXIST %%v\DBGS2BAT.BAT SET isp=%%v\
FIND "::" %isp%DBGS2BAT.BAT|FIND /V "0.BAT"|FIND /V "--"
:EndScr2B
FOR %%v IN (Ski Ord Scr ScrHlp io ScrFile BatFile Clue isp ScrEnd) DO SET %%v=
SET Fcount=
